      FUNCTION RANDOM(iseed)

c****************************************************************
c****************************************************************
c
c     Uniform pseudo-random number generator; mixed congruential
c  type; the function value is a real number from the 
c  interval (0,1), including 0, excluding 1.
c
c****************************************************************
c****************************************************************

c     ###  Passed Variables
c     ##
      implicit none
c
      integer*4 iseed
c     ###  Local Variables
c     ##
      real*8 RANDOM
      integer*4 ia, ib, ibc, ida, isum, iff, ie, ix, iy
      integer*4 ix2, ix1 
cc
c****************************************************************

      ib = iseed/65536
      ia = iseed-ib*65536
      ibc = ib*63253
      ida = ia*24301
      isum = ibc - 2147483647 + ida

      if (isum.le.0) then
         isum = isum + 2147483647
      else
         isum = isum - 1
      endif

      iff = isum/32768
      ie = isum - iff*32768
      ix = ie + ia
      iy = 453816691 - 2283*ia
      ix2 = ix/32768
      ix1 = ix - 32768*ix2
      iseed = ix1*65536 - 2147483647 + iy

      if (iseed.le.0) then
         iseed = iseed + 2147483647
      else
         iseed = iseed - 1
      endif
      
      RANDOM = iseed*4.65661287524579692410575D-10
    
      RETURN
      END
